#!%PERL%
#
# ruboard admin tool (rubadmin) %VERSION%
# $Id: rubadmin.PL,v 1.3 1998/09/13 07:07:08 am Exp $
#
# Based on (no serious modifications yet):
##############################################################################
# WWWBoard Admin                Version 2.0 ALPHA 2                          #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
#
# Home directory, prepended to all further paths and file names.
#
$homedir = "%HOMEDIR%";
#
# There should be no customization here in most simple cases.
##############################################################################

# Common subroutines
#
require "$homedir/rublib.pl";
umask(022);

# We deal only with html..
#
print "Content-type: text/html\n\n";

# Parsing form or input string and reading configuration
#
&parse_form;
&read_config;
$cgi_url=$admin_url;
$command=$FORM{"c"};
$action=$FORM{"action"};

###############################################################################
# Do we have password file?
#
if(! -s $passwd_file && $action ne "change_passwd")
{ &print_html_head("Asking Admin Password","Initializing administrator password");
  print <<EOH;
<CENTER>
Fill out the form below completely in order to use administration tool.
<P>
$passwd_file
<P>
EOH
  &print_html_hr;
  print <<EOH;
<FORM METHOD=post ACTION="$cgi_url">
<INPUT TYPE=HIDDEN NAME="config" VALUE="$config">
<INPUT TYPE=HIDDEN NAME="action" VALUE="change_passwd">
<TABLE BORDER=0>
<TR>
<TH ALIGN=LEFT>Username:</TH> <TD><INPUT TYPE=TEXT NAME="new_username"><BR></TD></TR>
<TR>
<TH ALIGN=LEFT>Password:</TH> <TD><INPUT TYPE=PASSWORD NAME="passwd_1"><BR></TD></TR>
<TR>
<TH ALIGN=LEFT>Re-type password:</TH> <TD><INPUT TYPE=PASSWORD NAME="passwd_2"><BR></TD></TR>
<TR>
<TD ALIGN=CENTER><INPUT TYPE=SUBMIT VALUE="Set Password"></TD>
<TD ALIGN=CENTER><INPUT TYPE=RESET></TD>
</TR></TABLE></CENTER>
</FORM>
EOH
  &print_html_footer;
}

###########################################################################
# Remove                                                                  #
#       This option is useful to see how the threads appear in the        #
#   wwwboard.html document.  It can give you a better idea of whether or  #
#   not you want to remove the whole thread or just part of it.           #
###########################################################################

elsif ($command eq 'remove')
{ &read_mesgfile;
  &print_html_head("Removing Messages","Removing messages from `$title'");
  print <<EOH;
Select below to remove those postings you wish to remove.
Checking the Input Box on the left will remove the whole thread
while checking the Input Box on the right to remove just that posting.
<p>
These messages have been left unsorted, so that you can see the order in
which they appear in the $mesgpage page.  This will give you an idea of
what the threads look like and is often more helpful than the sorted method.
<P>
EOH
  &show_buttons;
  &show_table_head("remove","remove");
  foreach (@ENTRIES)
   { $presubj=$postsubj="";
     if($TLA{$_})
      { $presubj="<B>";
        $postsubj="</B>";
      }
     print <<EOH;
<TR><TH><B>$_</B></TH>
<TD><INPUT TYPE=RADIO NAME="$_" VALUE="all"> ($THREADSIZE{$_})</TD>
<TD><INPUT TYPE=RADIO NAME="$_" VALUE="single"></TD>
<TD>$presubj<A HREF="$baseurl/$mesgdir/$_.$ext">$SUBJECT{$_}</A>$postsubj</TD>
<TD>$AUTHOR{$_}</TD>
<TD>$DATE{$_}<BR></TD>
</TR>
EOH
   }
  &show_table_foot;
}

###########################################################################
# Remove By Number                                                        #
#       This method is useful to see in what order the messages were      #
#   added to the wwwboard.html document.                                  #
###########################################################################

elsif ($command eq 'remove_by_num')
{ &read_mesgfile;
  &print_html_head("Removing messages by number","Removing messages from `$title' by number");
  print <<EOH;
Select below to remove those postings you wish to remove. Checking the
Input Box on the left will remove the whole thread while checking the
Input Box on the right to remove just that posting.
<P>
EOH
  &show_buttons;
  &show_table_head("remove","remove");
  foreach (@SORTED_ENTRIES)
   { $presubj=$postsubj="";
     if($TLA{$_})
      { $presubj="<B>";
        $postsubj="</B>";
      }
     print <<EOH;
<TR><TH><B>$_</B></TH>
<TD><INPUT TYPE=RADIO NAME="$_" VALUE="all"> ($THREADSIZE{$_})</TD>
<TD><INPUT TYPE=RADIO NAME="$_" VALUE="single"></TD>
<TD>$presubj<A HREF="$baseurl/$mesgdir/$_.$ext">$SUBJECT{$_}</A>$postsubj</TD>
<TD>$AUTHOR{$_}</TD>
<TD>$DATE{$_}<BR></TD>
</TR>
EOH
   }
  &show_table_foot;
}

###########################################################################
# Remove By Date                                                          #
#       Using this method allows you to delete all messages posted before #
#   a certain date.                                                       #
###########################################################################

elsif ($command eq 'remove_by_date')
{ &read_mesgfile;
  &print_html_head("Removing messages by date","Removing messages from `$title' by date");
  print <<EOH;
Select below to remove those postings you wish to remove. Checking the
input box beside a date will remove all postings that occurred on that date.
<P>
EOH
  &show_buttons;
  &show_table_head("remove_by_date_or_author","remove_by_date",4);
  print <<EOH;
<TR><TH>X</TH> <TH>Date</TH> <TH># of Messages</TH> <TH>Message Numbers<BR></TH></TR>
EOH

# Removing time if used
#
  if($use_time==1)
   { foreach $id (keys %DATE)
      { ($time,$day) = split(/\s+/,$DATE{$id});
         $DATE{$id} = $day;
      }
   }

# Grouping..
#
  undef(@used_values);
  foreach $value (sort (values %DATE))
   { $match = '0';
     $value_number = 0;
     foreach $used_value (@used_values)
      { if ($value eq $used_value)
         { $match = '1';
           last;
         }
      }
     if ($match == '0')
      { undef(@values); undef(@short_values);
        foreach $key (keys %DATE)
         { if ($value eq $DATE{$key})
            { $key_url = "<a href=\"$baseurl/$mesgdir/$key\.$ext\">$key</a>";
              push(@values,$key_url);
	      push(@short_values,$key);
              $value_number++;
            }
         }
        $form_value = $value;
        $form_value =~ s/\//_/g;
        print "<tr>\n";
        print "<td><input type=checkbox name=\"$form_value\" value=\"@short_values\"> </td><th>$value </th><td>$value_number </td><td>@values<br></td>\n";
        print "</tr>\n";
        push(@used_values,$value);
        push(@used_form_values,$form_value);
      }
   }
   print "</table><p><center>\n";
   print "<input type=hidden name=\"used_values\" value=\"@used_form_values\">\n";
   print "<input type=submit value=\"Remove Messages\"> <input type=reset>\n";
   print "</form></center>\n";
   &print_html_footer;
}

###########################################################################
# Remove By Author                                                        #
#       This option makes a list of all known authors and then groups     #
#    together there postings and allows you to remove them all at once.   #
###########################################################################

elsif ($command eq 'remove_by_author') {
   print "<html><head><title>Remove Messages From WWWBoard By Author</title></head>\n";
   print "<body><center><h1>Remove Messages From WWWBoard By Author</h1></center>\n";
   print "Checking the checkbox beside the name of an author will remove \n";
   print "all postings which that author has created.\n";
   print "<p>\n";
   print "<hr size=7 width=75%><center><font size=-1>\n";
   print "[ <a href=\"$cgi_url\?remove\">Remove</a> ] [ <a href=\"$cgi_url\?remove_by_date\">Remove by Date</a> ] [ <a href=\"$cgi_url\?remove_by_author\">Remove by Author</a> ] [ <a href=\"$cgi_url\?remove_by_num\">Remove by Message Number</a> ] [ <a hre
f=\"$baseurl/$mesgpage\">$title</a> ]\n";
   print "</font></center><hr size=7 width=75%>\n";
   print "<p>\n";
   print "<form method=POST action=\"$cgi_url\">\n";
   print "<input type=hidden name=\"action\" value=\"remove_by_date_or_author\">\n";
   print "<input type=hidden name=\"type\" value=\"remove_by_author\">\n";
   print "<center>\n";
   print "<table border>\n";
   print "<tr>\n";
   print "<th colspan=4>Username: <input type=text name=\"username\"> -- Password: <input type=password name=\"password\"><br></th>\n";
   print "</tr>\n";
   print "<tr>\n";
   print "<th>X </th><th>Author </th><th># of Messages </th><th>Message #'s<br></th></tr>\n";

   open(MSGS,"$basedir/$mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $line (@lines) {
      if ($line =~ /<!--t[ol][pa]: (.*)--><li><a href="$mesgdir\/\1\.$ext">.*<\/a> - <b>(.*)<\/b>\s+<i>.*<\/i>/) {
         $AUTHOR{$1} = $2;
      }
   }

   undef(@used_values);
   foreach $value (sort (values %AUTHOR)) {
      $match = '0';
      $value_number = 0;
      foreach $used_value (@used_values) {
         if ($value eq $used_value) {
            $match = '1';
            last;
         }
      }
      if ($match == '0') {
         undef(@values); undef(@short_values);
         foreach $key (keys %AUTHOR) {
            if ($value eq $AUTHOR{$key}) {
               $key_url = "<a href=\"$baseurl/$mesgdir/$key\.$ext\">$key</a>";
               push(@values,$key_url);
               push(@short_values,$key);
               $value_number++;
            }
         }
         $form_value = $value;
         $form_value =~ s/ /_/g;
         print "<tr>\n";
         print "<td><input type=checkbox name=\"$form_value\" value=\"@short_values\"> </td><th align=left>$value </th><td>$value_number </td><td>@values<br></td>\n";
         print "</tr>\n";
         push(@used_values,$value);
         push(@used_form_values,$form_value);
      }
   }
   print "</table><p>\n";
   print "<input type=hidden name=\"used_values\" value=\"@used_form_values\">\n";
   print "<input type=submit value=\"Remove Messages\"> <input type=reset>\n";
   print "</form></center>\n";
   print "</body></html>\n";

}

###########################################################################
# Change Password                                                         #
#       By calling this section of the script, the admin can change his or#
#   her password.							  #
###########################################################################

elsif ($command eq 'change_passwd')
{ &print_html_head("Change Admin Password","Changing administrator password");
  print <<EOH;
Fill out the form below completely to change your password and user name.
If new username is left blank, your old one will be assumed.
<P>
EOH
  &show_buttons;
  print <<EOH;
<FORM METHOD=post ACTION="$cgi_url">
<INPUT TYPE=HIDDEN NAME="config" VALUE="$config">
<INPUT TYPE=HIDDEN NAME="action" VALUE="change_passwd">
<CENTER><TABLE BORDER=0>
<TR>
<TH ALIGN=LEFT>Username:</TH> <TD><INPUT TYPE=TEXT NAME="username"><BR></TD></TR>
<TR>
<TH ALIGN=LEFT>Password:</TH> <TD><INPUT TYPE=PASSWORD NAME="password"><BR></TD></TR>
<TR>
<TH ALIGN=LEFT>New Username:</TH> <TD><INPUT TYPE=TEXT NAME="new_username"><BR></TD></TR>
<TR>
<TH ALIGN=LEFT>New Password:</TH> <TD><INPUT TYPE=PASSWORD NAME="passwd_1"><BR></TD></TR>
<TR>
<TH ALIGN=LEFT>Re-type New Password:</TH> <TD><INPUT TYPE=PASSWORD NAME="passwd_2"><BR></TD></TR>
<TR>
<TD ALIGN=CENTER><INPUT TYPE=SUBMIT VALUE="Change Password"></TD>
<TD ALIGN=CENTER><INPUT TYPE=RESET></TD>
</TR></TABLE></CENTER>
</FORM>
EOH
  &print_html_footer;
}

###########################################################################
# Remove Action                                                           #
#       This portion is used by the options remove and remove_by_num.     #
###########################################################################

elsif ($action eq 'remove')
{ &check_passwd;

  for($i = $FORM{'min'}; $i <= $FORM{'max'}; $i++)
   { if ($FORM{$i} eq 'all')
      { push(@ALL,$i);
      }
     elsif ($FORM{$i} eq 'single')
      { push(@SINGLE,$i);
      }
   }

  open(MSGS,"$mesgfile");
  @lines = <MSGS>;
  close(MSGS);

  foreach $single (@SINGLE)
   { foreach ($j = 0; $j <= @lines; $j++)
      { if ($lines[$j] =~ /<!--t[ol][pa]: $single-->/)
         { splice(@lines, $j, 3);
           $j -= 3;
         }
        elsif ($lines[$j] =~ /<!--end: $single-->/)
         { splice(@lines, $j, 1);
           $j--;
         }
      }
     $filename = "$basedir/$mesgdir/$single\.$ext";
     if (-e $filename)
      { unlink("$filename") || push(@NOT_REMOVED,$single);
      }
     else
      { push(@NO_FILE,$single);
      }
     push(@ATTEMPTED,$single);
   }

  foreach $all (@ALL)
   { undef($top); undef($bottom);
     undef(@DELETE);
     foreach ($j = 0;$j <= @lines;$j++)
      { if ($lines[$j] =~ /<!--t[ol][pa]: $all-->/)
         { $top = $j;
         }
        elsif ($lines[$j] =~ /<!--end: $all-->/)
         { $bottom = $j;
         }
      }
     if ($top && $bottom)
      { $diff = ($bottom - $top);
        $diff++;
        for ($k = $top;$k <= $bottom;$k++)
         { if ($lines[$k] =~ /<!--t[ol][pa]: (.*)-->/)
            { push(@DELETE,$1);
            }
         }
        splice(@lines, $top, $diff);
        foreach $delete (@DELETE)
         { $filename = "$basedir/$mesgdir/$delete\.$ext";
           if (-e $filename)
            { unlink($filename) || push(@NOT_REMOVED,$delete);
            }
           else
            { push(@NO_FILE,$delete);
            }
           push(@ATTEMPTED,$delete);
         }
      }
   }

  &lock_number;
  open(WWWBOARD,">$mesgfile.tmp");
  print WWWBOARD @lines;
  close(WWWBOARD);      
  rename("$mesgfile.tmp",$mesgfile);
  &unlock_number;

  &return_html($FORM{'type'});
}

###########################################################################
# Remove Action by Date or Author                                         #
#       This portion is used by the method remove_by_date or 		  #
#   remove_by_author.     		  				  #
###########################################################################

elsif ($action eq 'remove_by_date_or_author') {

   &check_passwd;

   @used_values = split(/\s/,$FORM{'used_values'});
   foreach $used_value (@used_values) {
      @misc_values = split(/\s/,$FORM{$used_value});
      foreach $misc_value (@misc_values) {
         push(@SINGLE,$misc_value);
      }
   }

   open(MSGS,"$basedir/$mesgfile");
   @lines = <MSGS>;
   close(MSGS);

   foreach $single (@SINGLE) {
      foreach ($j = 0;$j <= @lines;$j++) {
         if ($lines[$j] =~ /<!--t[ol][pa]: $single-->/) {
            splice(@lines, $j, 3);
            $j -= 3;
         }
         elsif ($lines[$j] =~ /<!--end: $single-->/) {
            splice(@lines, $j, 1);
            $j--;
         }
      }
      $filename = "$basedir/$mesgdir/$single\.$ext";
      if (-e $filename) {
         unlink("$filename") || push(@NOT_REMOVED,$single);
      }
      else {
         push(@NO_FILE,$single);
      }
      push(@ATTEMPTED,$single);
   }

   open(WWWBOARD,">$basedir/$mesgfile");
   print WWWBOARD @lines;
   close(WWWBOARD);

   &return_html($FORM{'type'});

}

elsif ($action eq 'change_passwd')
{ if(-s $passwd_file)
   { open(PASSWD,$passwd_file) || &error(passwd_file);
     $passwd_line = <PASSWD>;
     chop($passwd_line) if $passwd_line =~ /\n$/;
     close(PASSWD);
     ($username,$passwd) = split(/:/,$passwd_line);
   }

  $new_username = $FORM{'new_username'} ? $FORM{'new_username'} : $username;
  &error(not_same) unless
   $new_username &&
   $new_username !~ /:/ &&
   $FORM{'passwd_1'} &&
   $FORM{'passwd_1'} eq $FORM{'passwd_2'};

  $test_passwd = crypt($FORM{'password'}, substr($passwd, 0, 2));
  if(!-s $passwd_file || ($test_passwd eq $passwd && $FORM{'username'} eq $username))
   { $um=umask(077);
     open(PASSWD,">$passwd_file") || &error(no_change);
     $new_password = crypt($FORM{'passwd_1'}, substr($passwd, 0, 2));
     print PASSWD "$new_username:$new_password\n";
     close(PASSWD);
     umask($um);
   }
  else
   { &error(bad_combo);
   }

  &print_html_head("Password Changed","Ruboard admin password has been changed");
  &show_buttons("no_top");
  print "Your password for ruboard admin has been changed! Results are below:<p>";
  &print_html_hr;
  print "<b>New Username: $new_username<p>\n";
  print "New Password: " . &to_html_text($FORM{'passwd_1'}) . "</b><p>\n";
  &print_html_hr;
  print "Do not forget these, since they are now encoded in a file, and not readable!.\n";
  &print_html_footer(0);
}

###############################################################################
# Main menu
#
else
{ &print_html_head("`$title' administrator shell","$title; Administrator shell");
  print <<EOH;
<CENTER><TABLE><TR><TD>
<UL>
<LI>Messages
<UL>
<LI><A HREF="$cgi_url?config=$config&c=remove">Remove messages</A>
<LI><A HREF="$cgi_url?config=$config&c=remove_by_num">Remove messages by number</A>
<!-- <LI><A HREF="$cgi_url?config=$config&c=remove_by_date">Remove messages by date</A> -->
<!-- <LI><A HREF="$cgi_url?config=$config&c=remove_by_author">Remove messages by author</A> -->
</UL><BR>
<LI>Password
<UL>
<LI><A HREF="$cgi_url?config=$config&c=change_passwd">Change admin password</A>
</UL><BR>
<LI>Go to board
<UL>
<LI><A HREF="$mainpage">$title</A>
</UL>
</UL>
</TD></TR></TABLE></CENTER>
EOH
  &print_html_footer;
}

# Finish
#
exit(0);

###############################################################################
# Resulting pages
#
sub return_html
{ local($type) = $_[0];
  if ($type eq 'remove')
   { $head_text="Results of message board removal";
   }
  elsif ($type eq 'remove_by_num')
   { $head_text="Results of message board removal by number";
   }
  elsif ($type eq 'remove_by_date')
   { $head_text="Results of message board removal by date";
   }
  elsif ($type eq 'remove_by_author')
   { $head_text="Results of message board removal by author";
   }
  &print_html_head($head_text,$head_text);
  if ($type =~ /^remove/)
   { print "Below is a short summary of what messages were removed from $mainpage and the\n";
     print "$mesgdir directory.  All files that the script attempted to remove, were removed,\n";
     print "unless there is an error message stating otherwise.<BR>\n";
     &show_buttons;
     print "<TABLE>\n";
     print "<TR><TD>Attempted to Remove:</TD> <TD>@ATTEMPTED<BR></TD></TR>\n";
     print "<TR><TD>Files That Could Not Be Deleted:</TD> <TD>@NOT_REMOVED<BR></TD></TR>\n" if @NOT_REMOVED;
     print "<TR><TD>Files Not Found:</TD> <TD>@NO_FILE<BR></TD></TR>\n" if @NO_FILE;
     print "</TABLE>\n";
     &print_html_footer;
   }
}

###############################################################################
# Error
#
sub error
{ local($error) = $_[0];
  if ($error eq 'bad_combo')
   { &print_html_head("Bad username/password combination","Bad username/password combination");
     &show_buttons("no_top");
     print "You entered an invalid username/password pair. Please try again.<p>\n";
   }
  elsif ($error eq 'passwd_file') {
      print "<html><head><title>Could Not Open Password File For Reading</title></head>\n";
      print "<body><center><h1>Could Not Open Password File For Reading</h1></center>\n";
      print "Could not open the password file for reading!  Check permissions and try again.<p>\n";
   }
  elsif ($error eq 'not_same') {
      &print_html_head("Incorrect password or user name",
                       "Incorrect password or user name typed in");
      print "<CENTER>You've typed no user name, no passwords or two copies of password were not the same.<BR>\n";
      print "You may have mistyped, please try again.<P></CENTER>\n";
   }
  elsif ($error eq 'no_change') {
      print "<html><head><title>Could Not Open Password File For Writing</title></head>\n";
      print "<body><center><h1>Could Not Open Password File For Writing</h1></center>\n";
      print "Could not open the password file for writing!  Password not changed!<p>\n";
   }
  elsif ($error eq 'no_config') {
      print "<html><head><title>Could Not Open Configuration File</title></head>\n";
      print "<body><center><h1>Could Not Open Configuration File</h1></center>\n";
      print "Could not find or open the configuration!<p>\n";
   }
  elsif ($error eq 'wrong_cf') {
      print "<html><head><title>Wrong Configuration</title></head>\n";
      print "<body><center><h1>Wrong Configuration!</h1></center>\n";
      print "Fix configuration file!<p>\n";
   }
  else
   { &print_html_head("Unknown error","Unknown error");
     print "Something is wrong. Check script, configuration, environment, blood preasure etc..\n";
   }
  &print_html_footer(0);
  exit(0);
}

###############################################################################
# Checking Password
#
sub check_passwd
{ open(PASSWD,"$passwd_file") || &error(passwd_file);
  $passwd_line = <PASSWD>;
  close(PASSWD);
  chop($passwd_line) if $passwd_line =~ /\n$/;
  ($username,$passwd) = split(/:/,$passwd_line);
  $test_passwd = crypt($FORM{'password'}, substr($passwd, 0, 2));
  &error(bad_combo) if $test_passwd ne $passwd || $FORM{'username'} ne $username;
}

###############################################################################
# Common tool buttons
#
sub show_buttons
{ &print_html_hr unless $_[0] eq "no_top";
  print <<EOH;
<CENTER><FONT SIZE=-1>
[<A HREF="$cgi_url\?config=$config">Main menu</A>]
[<A HREF="$cgi_url\?config=$config&c=remove">Remove</A>]
[<A HREF="$cgi_url\?config=$config&c=remove_by_num">Remove by Message Number</A>]
<!-- [<A HREF="$cgi_url\?config=$config&c=remove_by_date">Remove by Date</A>] -->
<!-- [<A HREF="$cgi_url\?config=$config&c=remove_by_author">Remove by Author</A>] -->
</FONT></CENTER>
EOH
  &print_html_hr unless $_[0] eq "no_bottom";
}

###############################################################################
# Reading entries from $mesgfile
#
sub read_mesgfile
{ local($line);
  open(MSGS,"$mesgfile");
  local(@lines) = <MSGS>;
  close(MSGS);

  foreach $line (@lines)
   { if ($line =~ /<!--t[ol][pa]: (.*)--><li><a href="$mesgdir\/\1\.$ext">(.*)<\/a> - <b>(.*)<\/b>\s+<i>(.*)<\/i>/i)
      { push(@ENTRIES,$1);
        $SUBJECT{$1} = $2;
        $AUTHOR{$1} = $3;
        $DATE{$1} = $4;
        $TLA{$1}=1 if $line =~ /<!--tla/;
      }
     elsif ($line =~ /\(<!--responses: (\d+)-->(\d+)\)/)
      { $THREADSIZE{$1}=$2;
      }
   }

  @SORTED_ENTRIES = (sort { $a <=> $b } @ENTRIES);
  $max = $SORTED_ENTRIES[$#SORTED_ENTRIES];
  $min = $SORTED_ENTRIES[0];

  print "<INPUT TYPE=HIDDEN NAME=\"min\" VALUE=\"$min\">\n";
  print "<INPUT TYPE=HIDDEN NAME=\"max\" VALUE=\"$max\">\n";
  print "<INPUT TYPE=HIDDEN NAME=\"type\" VALUE=\"remove\">\n";
}

###############################################################################
# Head of postings list
#
sub show_table_head
{ local($action) = $_[0];
  local($type) = $_[1];
  local($cols) = $_[2] ? $_[2] : 6;
  print <<EOH;
<FORM METHOD=POST ACTION="$cgi_url">
<INPUT TYPE=HIDDEN NAME="action" VALUE="$action">
<INPUT TYPE=HIDDEN NAME="config" VALUE="$config">
<INPUT TYPE=HIDDEN NAME="min" VALUE="$min">
<INPUT TYPE=HIDDEN NAME="max" VALUE="$max">
<INPUT TYPE=HIDDEN NAME="type" VALUE="$type">
<TABLE BORDER WIDTH=100%>
<TR>
<TH COLSPAN=$cols>Username: <INPUT TYPE=TEXT NAME="username">
-- Password: <INPUT TYPE=PASSWORD NAME="password"><BR></TH>
</TR>
<TR>
EOH
  print <<EOH if $cols==6;
<TH>Post #</TH> <TH>Thread</TH> <TH>Single</TH> <TH>Subject</TH> <TH>Author</TH> <TH>Date<BR></TH>
</TR>
EOH
}

###############################################################################
# Table, form and whole html document footer
#
sub show_table_foot
{ print <<EOH;
</TABLE>
<CENTER><P>
<INPUT TYPE=SUBMIT VALUE=\"Remove Messages\">
<INPUT TYPE=RESET>
</FORM>
EOH
  &print_html_footer;
}
