#!%PERL%
#
# ruboard %VERSION%, Copyright (c) 1998 by Andrew Maltsev, <am@amsoft.ru>
# $Id: ruboard.PL,v 1.4 1998/09/16 00:05:11 am Exp $
#
# To alter supported languages search for @LANG@. Only russian and
# english languages supported now.
#
# Based on (look History for list of what was changed):
##############################################################################
# WWWBoard                      Version 2.0 ALPHA 2                          #
# Copyright 1996 Matt Wright    mattw@worldwidemart.com                      #
# Created 10/21/95              Last Modified 11/25/95                       #
# Scripts Archive at:           http://www.worldwidemart.com/scripts/        #
##############################################################################
# COPYRIGHT NOTICE                                                           #
# Copyright 1996 Matthew M. Wright  All Rights Reserved.                     #
#                                                                            #
# WWWBoard may be used and modified free of charge by anyone so long as      #
# this copyright notice and the comments above remain intact.  By using this #
# code you agree to indemnify Matthew M. Wright from any liability that      #  
# might arise from it's use.                                                 #  
#                                                                            #
# Selling the code for this program without prior written consent is         #
# expressly forbidden.  In other words, please ask first before you try and  #
# make money off of my program.                                              #
#                                                                            #
# Obtain permission before redistributing this software over the Internet or #
# in any other medium.  In all cases copyright and header must remain intact.#
##############################################################################
# 
# Home directory, prepended to all further paths and file names.
#
$homedir = "%HOMEDIR%";
#
# There should be no customization here in most simple cases.
###########################################################################

# Common subroutines
#
require "$homedir/rublib.pl";
umask 022;

# Get Form Information
#
&parse_form;

# Get config, it may depend on form's content
#
&read_config;

# Fixing form
#
&fix_form;

# Get the Data Number and lock it
#
&get_number;

# Put items into nice variables
#
&get_variables;

# Open the new file and write information to it.
#
&new_file;

# Open the Main WWWBoard File to add link
#
&main_page;

# Now Add Thread to Individual Pages
#
&thread_pages if $num_followups >= 1;

# Return the user HTML
#
&return_html;

# Increment Number
#
&increment_num;

# Finish
#
exit(0);

############################
# Get Data Number Subroutine
#
sub get_number
{ &lock_number;
  open(NUMBER,$datafile);
  $num = <NUMBER>;
  close(NUMBER);
  $num++;
}

#####################################################################
# Fixing form entries (can't do it before because there were no
# configuration)
#
sub fix_form
{ foreach $name (keys %FORM)
   { $FORM{$name} =~ s/<([^>]|\n)*>//g unless $name eq "body";
   }
}

##############################
# Get Variables
#
sub get_variables
{ if($FORM{'followup'})
   { $followup = "1";
     @followup_num = split(/,/,$FORM{'followup'});
     $num_followups = @followups = @followup_num;
     $last_message = pop(@followups);
     $origdate = "$FORM{'origdate'}";
     $origname = "$FORM{'origname'}";
     $origsubject = "$FORM{'origsubject'}";
     $origemail = "$FORM{'origemail'}";
   }
  else
   { $followup = "0";
   }

  $name = "$FORM{'name'}";
  $email = "$FORM{'email'}" if $FORM{'email'} =~ /.*\@.*\..*/;
  $subject = "$FORM{'subject'}";
  if ($FORM{'url'} =~ /.*\:.*\..*/ && $FORM{'url_title'})
   { $message_url = "$FORM{'url'}";
     $message_url_title = "$FORM{'url_title'}";
   }
  $message_img = "$FORM{'img'}" if $FORM{'img'} =~ /.*tp:\/\/.*\..*/;
  $body = "$FORM{'body'}";
  $body =~ s/\r//g;
  $hidden_body = "$body" if $quote_text;

  ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
  $sec = "0$sec" if $sec < 10;
  $min = "0$min" if $min < 10;
  $hour = "0$hour" if $hour < 10;
  $month = ($mon + 1);
  $year += 1900;

#@LANG@#
  if($language eq "russian")		# RUSSIAN
   { @months = ("","","","","","",
                "","","","","","");
     if ($use_time) { $date = "$hour\:$min\:$sec $mday/$month/$year"; }
     else { $date = "$month/$mday/$year"; }
     $long_date = "$mday $months[$mon] $year  $hour:$min:$sec";
   }
  else					# ENGLISH (default)
   { @months = ("January","February","March","April","May","June",
                "July","August","September","October","November","December");
     if ($use_time) { $date = "$hour\:$min\:$sec $month/$mday/$year"; }
     else { $date = "$month/$mday/$year"; }
     $long_date = "$months[$mon] $mday, $year at $hour\:$min\:$sec";
   }

# Various checks now..
#
  if($FORM{"post"} || ($body eq "" && $subject eq "" && $name eq ""))	# posting new message
   { print "Content-type: text/html\n\n";
     &print_html_head($title,$title);
     print "<CENTER>";
#@LANG@#
     if($language eq "russian")
      { print "    ,    .\n";
      }
     else
      { print "Please fill at least Name, Subject and message body fields.\n";
      }
     print "</CENTER>\n";
     &rest_of_form;
     exit(0);
   }
  $subject =~ s/^\s+//;
  $body =~ s/^\n//g;
  &error(no_name) if $name eq "";
  &error(no_subject) if $subject eq "";
  &error(no_body) if $body eq "";
}

###############################################################################
# Print message buttons
#
sub print_msg_buttons
{ print <<EOH;
<FONT SIZE=-1>
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=100%>
<TR BGCOLOR=$bg_sep>
EOH
  print "<TD ALIGN=CENTER><A HREF=\"#followups\">$t_followups</A></TD>\n" .
        "<TD ALIGN=CENTER><A HREF=\"#postfp\">$t_post_followup</A></TD>\n" if $show_refs;
  print "<TD ALIGN=CENTER><A HREF=\"$mainpage\">$title</A></TD>\n";
  print "<TD ALIGN=CENTER><A HREF=\"$faqfile\">$t_faq</A></TD>\n" if $show_faq;
  print "</TR></TABLE></FONT>\n";
}
 
################################################
# New File Subroutine
#
sub new_file
{ open(SAVESTD,">&STDOUT");
  open(STDOUT,">$basedir/$mesgdir/$num\.$ext") || die "Can't open message: $!\n";

  &print_html_head("$subject ($title)");
  &print_msg_buttons;

  $h_subject=&to_html_text($subject);
  print <<EOH;
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=100%>
<TR BGCOLOR=$bg_subject><TH COLSPAN=2>$h_subject</TH></TR>
<TR BGCOLOR=$bg_sep>
EOH
  print "<TD>&nbsp;$t_author: ";
  print "<A HREF=\"mailto:$email\">" if $email;
  print $name;
  print "</A>" if $email;
  print "</TD>\n<TD ALIGN=RIGHT>$long_date&nbsp;</TD></TR>\n";

  if($followup == 1)
   { print "<TR BGCOLOR=$bg_sep><TD COLSPAN=2 ALIGN=CENTER><FONT SIZE=-1><I>";
#@LANG@#
     if($language eq "russian")
      { print "(  :\n";
        print "<B><A HREF=\"$last_message\.$ext\">$origsubject</A></B> (\n";
        print "<A HREF=\"mailto:$origemail\">" if $origemail;
        print "$origname";
        print "</A>" if $origemail;
        print ") $origdate\n";
      }
     else
      { print "(in reply to:\n";
        print "<B><A HREF=\"$last_message\.$ext\">$origsubject</A></B> posted by\n";
        print "<A HREF=\"mailto:$origemail\">" if $origemail;
        print "$origname";
        print "</A>" if $origemail;
        print " on $origdate\n";
      }
     print "</I></FONT></TD></TR>\n";
   }
  print "</TABLE>\n";

# Image
#
  print "<CENTER><IMG SRC=\"$message_img\"></CENTER><P>\n" if $message_img;

# Body
#
  $_=&to_html_text($body);
  if($followup)
   { split(/\n/);
     local($cs)=&to_html_text($cite_symbol);
     for($i=0; $i!=@_; $i++)
      { $_[$i]="<I>$_[$i]</I>" if $_[$i] =~ /^${cs}/; # substr($_[$i],0,1) eq $cite_symbol;
      }
     $_=join("\n",@_);
   }
  s/\n$//g;
  s/\n/<BR>\n/g;
  print <<EOH;
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH=100%>
<TR><TD>&nbsp;&nbsp;&nbsp;</TD>
<TD WIDTH=100%>
$_
EOH
  print "<CENTER><B><A HREF=\"$message_url\">$message_url_title</A></B></CENTER>\n"
   if $message_url;
  print <<EOH;
</TD>
<TD>&nbsp;&nbsp;&nbsp</TD>
</TR>
<TR BGCOLOR=$bg_sep>
<TH COLSPAN=3>&nbsp;<A NAME="followups">$t_followups</A></TH></TR>
<TR><TD>&nbsp;</TD><TD>
<UL><!--insert: $num-->
</UL><!--end: $num-->
</TD><TD></TD></TR>
<TR BGCOLOR=$bg_sep>
<TH COLSPAN=3>&nbsp;<A NAME="postfp">$t_post_followup</A></TH></TR>
<TR><TD></TD><TD>
EOH
  $origname=$name;
  $name="";
  $origemail=$email;
  $email="";
  $origsubject=$subject;
  $subject="Re: $subject" unless $subject =~ "^[rR][eE]: ";
  $origdate=$long_date;
  $origmessage_url=$message_url;
  $message_url="";
  $origmessage_url_title=$message_url_title;
  $message_url_title="";
  $origmessage_img=$message_img;
  $message_img="";
  $tmp_body=$body;
  chop($body) while $body =~ /[\n\r]$/;
  $body =~ s/\n/\n${cite_symbol} /g;
  $body="$cite_symbol $body";
  push(@followup_num,$num); $followup=1;
  &rest_of_form(1);				# Form for followup
  $subject=$origsubject;
  $name=$origname;
  $message_url=$origmessage_url;
  $message_url_title=$origmessage_url_title;
  $message_img=$origmessage_img;
  $followup=0 if scalar(@followup_num) == 1;
  print <<EOH;
</TD><TD></TD>
</TR>
<TR BGCOLOR=$bg_sep><TD COLSPAN=3 ALIGN=RIGHT>
EOH
  &print_html_footer(1);
  print "&nbsp;&nbsp;</TD></TR></TABLE>\n";
  print "</BODY></HTML>\n";
  close(STDOUT);
  open(STDOUT,">&SAVESTD");
}

###############################################################################
# Main WWWBoard Page Subroutine
#
sub main_page
{ open(MAIN,"<$mesgfile") || die $!;
  @main = <MAIN>;
  close(MAIN);
  $_=scalar(@main);

  open(MAIN,">$mesgfile") || die $!;
  if (!$followup)
   { $entries=1;
     foreach $main_line (@main)
      { if ($main_line =~ /<!--begin-->/)
         { print MAIN $main_line;
	   print MAIN "<!--tla: $num--><li><a href=\"$mesgdir/$num\.$ext\">$subject</a> " .
	              "- <b>$name</b> <i>$date</i>\n";
           print MAIN "(<!--responses: $num-->0)\n";
           print MAIN "<ul><!--insert: $num-->\n";
           print MAIN "</ul><!--end: $num-->\n";
           next;
         }
        elsif (!$skip && $max_entries && $main_line =~ /<!--tla: \d+-->/)
         { $skip=1 if ++$entries > $max_entries;
         }
        elsif ($skip && $main_line =~ /<!--end-->/)
         { $skip=0;
         }
        print MAIN "$main_line" unless $skip;
      }
   }
  else
   { foreach $main_line (@main)
      { $work = 0;
        if ($main_line =~ /<!--insert: $last_message-->/)
         { print MAIN $main_line;
           print MAIN "<!--top: $num--><li><a href=\"$mesgdir/$num\.$ext\">$subject</a> " .
                      "- <b>$name</b> <i>$date</i>\n";
           print MAIN "(<!--responses: $num-->0)\n";
           print MAIN "<ul><!--insert: $num-->\n";
           print MAIN "</ul><!--end: $num-->\n";
         }
        elsif ($main_line =~ /\(<!--responses: (.*)-->(.*)\)/)
         { $response_num = $1;
           $num_responses = $2;
           $num_responses++;
           foreach $followup_num (@followup_num)
            { if ($followup_num == $response_num)
               { print MAIN "(<!--responses: $followup_num-->$num_responses)\n";
		 $work = 1;
               }
            }
           print MAIN $main_line if $work != 1;
         }
        else
         { print MAIN $main_line;
         }
      }
   }
  close(MAIN);
}

###############################################################################
# Add Followup Threading to Individual Pages
#
sub thread_pages
{ foreach $followup_num (@followup_num)
   { open(FOLLOWUP,"$basedir/$mesgdir/$followup_num\.$ext");
     @followup_lines = <FOLLOWUP>;
     close(FOLLOWUP);

     open(FOLLOWUP,">$basedir/$mesgdir/$followup_num\.$ext");
     foreach $followup_line (@followup_lines)
      { $work = 0;
        if ($followup_line =~ /<!--insert: $last_message-->/)
         { print FOLLOWUP $followup_line;
           print FOLLOWUP "<!--top: $num--><LI><A HREF=\"$num\.$ext\">$subject</A>\n" .
                          "<B>$name</B> <I>$date</I>\n";
           print FOLLOWUP "(<!--responses: $num-->0)\n";
           print FOLLOWUP "<UL><!--insert: $num-->\n";
           print FOLLOWUP "</UL><!--end: $num-->\n";
         }
        elsif ($followup_line =~ /\(<!--responses: (.*)-->(.*)\)/)
         { $response_num = $1;
           $num_responses = $2;
           $num_responses++;
           foreach $followup_num (@followup_num)
            { if ($followup_num == $response_num)
               { print FOLLOWUP "(<!--responses: $followup_num-->$num_responses)\n";
                 $work = 1;
               }
            }
           if ($work != 1)
            { print FOLLOWUP "$followup_line";
            }
         }
        else
         { print FOLLOWUP "$followup_line";
         }
      }
     close(FOLLOWUP);
   }
}

###############################################################################
# We'd created message on disk. Now pointing browser to it.
#
sub return_html
{ print "Location: $baseurl/$mesgdir/$num.$ext\n\n";
  print "Please go to $baseurl/$mesgdir/$num.$ext\n";
}

###############################################################################
# Incrementing message number and unlocking
#
sub increment_num
{ local($um)=umask(077);
  open(NUM,">$datafile") || die $!;
  print NUM "$num\n";
  close(NUM);
  umask($um);
  &unlock_number;
}

###############################################################################
# Error message heading
#
sub print_err_head
{ &print_html_head("Error: $_[0] ($title)","Error: $_[0]");
  print "<CENTER>\n" . $_[1] . "\n";
  print "Please correct error below and re-submit form.\n" unless $_[2];
  print "</CENTER>\n";
  &print_html_hr;
}

###############################################################################
# Error message
#
sub error {
   local($error) = $_[0];
   local($errtext) = $_[1];

   print "Content-type: text/html\n\n";

   if ($error eq 'no_name')
    { &print_err_head("no Name field",
                      "You forgot to fill in the 'Name' field in your posting.");
      &rest_of_form;
    }
   elsif ($error eq 'no_subject')
    { &print_err_head("no Subject field",
                      "You forgot to fill in the 'Subject' field in your posting.");
      &rest_of_form;
    }
   elsif ($error eq 'no_body')
    { &print_err_head("no message body",
                      "Empty messages disallowed!");
      &rest_of_form;
    }
   elsif ($error eq 'no_config')
    { &print_err_head("no configuration found",
                      "Hm.. System error or attempted hacking -- no configuration file found.",
                      1);
      &print_html_footer;
    }
   elsif ($error eq 'wrong_cf')
    { &print_err_head("wrong configuration",
                      "System error, configuration is wrong: $errtext");
      &rest_of_form;
    }
   else
    { &print_err_head("undefined error");
      &rest_of_form;
    }
   exit(0);
}

###############################################################################
# The form itself. If some values are known they used as defaults.
#
sub rest_of_form
{ print "<FORM METHOD=POST ACTION=\"$cgi_url\">\n";
  print "<INPUT TYPE=HIDDEN NAME=config VALUE=$config>\n" if $config;
  if ($followup == 1)
   { $h_origsubject=&hf($origsubject);
     $h_origname=&hf($origname);
     $h_origemail=&hf($origemail);
     $h_followup="";
     foreach $_ (@followup_num)
      { $h_followup.="$_,";
      }
     chop($h_followup);
     print <<EOH;
<INPUT TYPE=HIDDEN NAME="origsubject" value="$h_origsubject">
<INPUT TYPE=HIDDEN NAME="origname" value="$h_origname">
<INPUT TYPE=HIDDEN NAME="origemail" value="$h_origemail">
<INPUT TYPE=HIDDEN NAME="origdate" value="$origdate">
<INPUT TYPE=HIDDEN NAME="followup" value="$h_followup">
EOH
   }
  $h_name=&hf($name);
  $h_email=&hf($email);
  $h_subject=&hf($subject);
  $h_body=&to_html_text($body);
  $h_url=&hf($message_url);
  $h_url_text=&hf($message_url_title);
  $h_image=&hf($message_img);
  print <<EOH;
<CENTER><TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0>
<TR><TD>$t_name:&nbsp;</TD>
<TD ALIGN=RIGHT>&nbsp;<INPUT TYPE=TEXT NAME="name" VALUE="$h_name" SIZE=50><BR></TD>
</TR>
<TR><TD>$t_email:&nbsp;</TD>
<TD ALIGN=RIGHT>&nbsp;<INPUT TYPE=TEXT NAME="email" VALUE="$h_email" SIZE=50><BR></TD>
</TR>
<TR><TD>$t_subject:&nbsp;</TD>
EOH
  print "<TD ALIGN=RIGHT>&nbsp;";
  if($subject && $subject_line==1)
   { print "$h_subject";
     print "<INPUT TYPE=HIDDEN NAME=\"subject\" VALUE=\"$h_subject\">";
   } 
  else
   { print "<INPUT TYPE=TEXT NAME=\"subject\" VALUE=\"$h_subject\" SIZE=50>";
   }
  print <<EOH;
<BR></TD></TR>
<TR><TD COLSPAN=2 ALIGN=CENTER>
<TEXTAREA COLS=70 ROWS=10 NAME="body">$h_body
</TEXTAREA></BR></TD>
</TR>
<TR><TD>$t_link_url:&nbsp;</TD>
<TD ALIGN=RIGHT>&nbsp;<INPUT TYPE=TEXT NAME="url" VALUE="$h_url" SIZE=50><BR></TD>
</TR>
<TR><TD>$t_link_text:&nbsp;</TD>
<TD ALIGN=RIGHT>&nbsp;<INPUT TYPE=TEXT NAME="url_title" VALUE="$h_url_text" SIZE=50><BR></TD>
</TR>
<TR><TD>$t_image:&nbsp;</TD>
<TD ALIGN=RIGHT>&nbsp;<INPUT TYPE=TEXT NAME="img" VALUE="$h_image" SIZE=50><BR>
</TR>
</TABLE>
<INPUT TYPE=SUBMIT VALUE="$t_post">&nbsp;&nbsp;&nbsp;<INPUT TYPE=RESET VALUE="$t_reset">
</CENTER>
</FORM>
EOH
   &print_html_footer unless $_[0];
}
